'----------------------------------------------------
'File version: 1; name: run02.bas
'Required: Documentation.ico
'Description:
'How to run an(other) external application, hidden (minimized)
'(C) Serban Stanescu, 2001
'Rapid-Q Documentation Project
'----------------------------------------------------
'NOTE: This is an easy solution. A harder one (but more efficient)
'is to use WinAPI to set App's thread priority level and 
'THEN launch it IN BACKGROUND to prevent it get the focus.
'
 $INCLUDE "RAPIDQ.INC"                
 $RESOURCE titlebar_ICO AS "Documentation.ico"  

 Declare Sub EndProgram ' Trigger for mExit menu option
 Declare Sub Button1Click ' Trigger for ButRunFocus
 Declare Sub Button2Click ' Trigger for ButRunHidden

 Create Form as QForm 
    Caption="Run application buttons"
    ICOHandle=titlebar_ICO  
    Width=450
    Height=300
    Center
       Create MainMenu as QMainMenu
          Create mExit as QMenuItem
             Caption="E&xit Program"
             onClick=EndProgram
          End Create
       End Create 
       Create ButRunFocus as QButton
         Left=100
         Top=100
         Width=100
         Height=30
         Caption="Run &Focused"
         onClick=Button1Click
       End Create
       Create ButRunHidden as QButton
         Left=210
         Top=100
         Width=150
         Height=30
         Caption="Run Minimized/&Hidden"
         onClick=Button2Click
       End Create
       Create StatusBar as QStatusBar   
          AddPanels Date$,"RapidQ Documentation Project - Learn By Example" 
          Panel(0).Width=70
       End Create 
    ShowModal
 End Create

 Sub Button1Click
   'We don't want to hide the App, so we let the default window state
   Run "D:\Rapid-Q\RAPIDQ.EXE" 'Change the path according to the real one!
 End Sub  
 Sub Button2Click
   Dim ResultVal
   ' And now, we'll launch a minimized App:
   'You need to change the path...
   ResultVal = Shell("C:\Dev-Pas\DevPas.exe" , 7 ) 'Change the path...
   If ResultVal > 0 then 
   Form.WindowState=2
   Form.Repaint
   End If
 End Sub  

 Sub EndProgram
   Form.Close
 End Sub  

